// hdmi_rx.v

// Generated using ACDS version 20.2 50

`timescale 1 ps / 1 ps
module hdmi_rx (
		input  wire         reset,                //                reset.export
		input  wire         reset_vid,            //            reset_vid.export
		input  wire         vid_clk,              //              vid_clk.export
		input  wire         ls_clk,               //               ls_clk.export
		output wire         locked,               //               locked.export
		output wire         mode,                 //                 mode.export
		output wire [11:0]  ctrl,                 //                 ctrl.export
		output wire         vid_lock,             //             vid_lock.export
		output wire [1:0]   vid_de,               //               vid_de.export
		output wire [95:0]  vid_data,             //             vid_data.export
		output wire [1:0]   vid_hsync,            //            vid_hsync.export
		output wire [1:0]   vid_vsync,            //            vid_vsync.export
		input  wire [19:0]  in_b,                 //                 in_b.export
		input  wire [19:0]  in_r,                 //                 in_r.export
		input  wire [19:0]  in_g,                 //                 in_g.export
		input  wire         in_lock,              //              in_lock.export
		output wire         aux_valid,            //            aux_valid.export
		output wire [71:0]  aux_data,             //             aux_data.export
		output wire         aux_sop,              //              aux_sop.export
		output wire         aux_eop,              //              aux_eop.export
		output wire         aux_error,            //            aux_error.export
		output wire [5:0]   gcp,                  //                  gcp.export
		output wire [111:0] info_avi,             //             info_avi.export
		output wire [60:0]  info_vsi,             //             info_vsi.export
		output wire [6:0]   aux_pkt_addr,         //         aux_pkt_addr.export
		output wire [71:0]  aux_pkt_data,         //         aux_pkt_data.export
		output wire         aux_pkt_wr,           //           aux_pkt_wr.export
		output wire [19:0]  audio_CTS,            //            audio_CTS.export
		output wire [19:0]  audio_N,              //              audio_N.export
		output wire [255:0] audio_data,           //           audio_data.export
		output wire         audio_de,             //             audio_de.export
		output wire [47:0]  audio_info_ai,        //        audio_info_ai.export
		output wire [164:0] audio_metadata,       //       audio_metadata.export
		output wire [4:0]   audio_format,         //         audio_format.export
		input  wire         scdc_i2c_clk,         //         scdc_i2c_clk.clk
		input  wire [7:0]   scdc_i2c_addr,        //        scdc_i2c_addr.export
		input  wire [7:0]   scdc_i2c_wdata,       //       scdc_i2c_wdata.export
		input  wire         scdc_i2c_r,           //           scdc_i2c_r.export
		input  wire         scdc_i2c_w,           //           scdc_i2c_w.export
		output wire [7:0]   scdc_i2c_rdata,       //       scdc_i2c_rdata.export
		output wire         TMDS_Bit_clock_Ratio, // TMDS_Bit_clock_Ratio.export
		input  wire         in_5v_power,          //          in_5v_power.export
		input  wire         in_hpd                //               in_hpd.export
	);

	hdmi_rx_altera_hdmi_1940_g5zh3uy #(
		.FAMILY                ("Stratix 10"),
		.SYMBOLS_PER_CLOCK     (2),
		.PIXELS_PER_CLOCK      (2),
		.TRANSCEIVER_WIDTH     (20),
		.DISABLE_ALIGN_DESKEW  (0),
		.ENABLE_FAST_ALIGNMENT (0),
		.SUPPORT_AUXILIARY     (1),
		.SUPPORT_DEEP_COLOR    (1),
		.SUPPORT_AUDIO         (1),
		.SUPPORT_32CHAN_AUDIO  (0),
		.SUPPORT_FRL           (0),
		.SYMBOLS_PER_CLOCK_20  (2),
		.SYMBOLS_PER_CLOCK_21  (2),
		.SYMBOLS_PER_CLOCK_FRL (16),
		.SCDC_IEEE_ID          (24'b000000000000000000000000),
		.SCDC_DEVICE_STRING    (64'b0000000000000000000000000000000000000000000000000000000000000000),
		.SCDC_HW_REVISION      (8'b00000000)
	) hdmi_rx (
		.reset                (reset),                                                                                        //   input,    width = 1,                reset.export
		.reset_vid            (reset_vid),                                                                                    //   input,    width = 1,            reset_vid.export
		.vid_clk              (vid_clk),                                                                                      //   input,    width = 1,              vid_clk.export
		.ls_clk               (ls_clk),                                                                                       //   input,    width = 1,               ls_clk.export
		.locked               (locked),                                                                                       //  output,    width = 1,               locked.export
		.mode                 (mode),                                                                                         //  output,    width = 1,                 mode.export
		.ctrl                 (ctrl),                                                                                         //  output,   width = 12,                 ctrl.export
		.vid_lock             (vid_lock),                                                                                     //  output,    width = 1,             vid_lock.export
		.vid_de               (vid_de),                                                                                       //  output,    width = 2,               vid_de.export
		.vid_data             (vid_data),                                                                                     //  output,   width = 96,             vid_data.export
		.vid_hsync            (vid_hsync),                                                                                    //  output,    width = 2,            vid_hsync.export
		.vid_vsync            (vid_vsync),                                                                                    //  output,    width = 2,            vid_vsync.export
		.in_b                 (in_b),                                                                                         //   input,   width = 20,                 in_b.export
		.in_r                 (in_r),                                                                                         //   input,   width = 20,                 in_r.export
		.in_g                 (in_g),                                                                                         //   input,   width = 20,                 in_g.export
		.in_lock              (in_lock),                                                                                      //   input,    width = 1,              in_lock.export
		.aux_valid            (aux_valid),                                                                                    //  output,    width = 1,            aux_valid.export
		.aux_data             (aux_data),                                                                                     //  output,   width = 72,             aux_data.export
		.aux_sop              (aux_sop),                                                                                      //  output,    width = 1,              aux_sop.export
		.aux_eop              (aux_eop),                                                                                      //  output,    width = 1,              aux_eop.export
		.aux_error            (aux_error),                                                                                    //  output,    width = 1,            aux_error.export
		.gcp                  (gcp),                                                                                          //  output,    width = 6,                  gcp.export
		.info_avi             (info_avi),                                                                                     //  output,  width = 112,             info_avi.export
		.info_vsi             (info_vsi),                                                                                     //  output,   width = 61,             info_vsi.export
		.aux_pkt_addr         (aux_pkt_addr),                                                                                 //  output,    width = 7,         aux_pkt_addr.export
		.aux_pkt_data         (aux_pkt_data),                                                                                 //  output,   width = 72,         aux_pkt_data.export
		.aux_pkt_wr           (aux_pkt_wr),                                                                                   //  output,    width = 1,           aux_pkt_wr.export
		.audio_CTS            (audio_CTS),                                                                                    //  output,   width = 20,            audio_CTS.export
		.audio_N              (audio_N),                                                                                      //  output,   width = 20,              audio_N.export
		.audio_data           (audio_data),                                                                                   //  output,  width = 256,           audio_data.export
		.audio_de             (audio_de),                                                                                     //  output,    width = 1,             audio_de.export
		.audio_info_ai        (audio_info_ai),                                                                                //  output,   width = 48,        audio_info_ai.export
		.audio_metadata       (audio_metadata),                                                                               //  output,  width = 165,       audio_metadata.export
		.audio_format         (audio_format),                                                                                 //  output,    width = 5,         audio_format.export
		.scdc_i2c_clk         (scdc_i2c_clk),                                                                                 //   input,    width = 1,         scdc_i2c_clk.clk
		.scdc_i2c_addr        (scdc_i2c_addr),                                                                                //   input,    width = 8,        scdc_i2c_addr.export
		.scdc_i2c_wdata       (scdc_i2c_wdata),                                                                               //   input,    width = 8,       scdc_i2c_wdata.export
		.scdc_i2c_r           (scdc_i2c_r),                                                                                   //   input,    width = 1,           scdc_i2c_r.export
		.scdc_i2c_w           (scdc_i2c_w),                                                                                   //   input,    width = 1,           scdc_i2c_w.export
		.scdc_i2c_rdata       (scdc_i2c_rdata),                                                                               //  output,    width = 8,       scdc_i2c_rdata.export
		.TMDS_Bit_clock_Ratio (TMDS_Bit_clock_Ratio),                                                                         //  output,    width = 1, TMDS_Bit_clock_Ratio.export
		.in_5v_power          (in_5v_power),                                                                                  //   input,    width = 1,          in_5v_power.export
		.in_hpd               (in_hpd),                                                                                       //   input,    width = 1,               in_hpd.export
		.hdcp_reset           (1'b0),                                                                                         // (terminated),                                    
		.hdcp_i2c_clk         (1'b0),                                                                                         // (terminated),                                    
		.rpt_msg_clk          (1'b0),                                                                                         // (terminated),                                    
		.crypto_clk           (1'b0),                                                                                         // (terminated),                                    
		.hdcp_i2c_stop_det    (1'b0),                                                                                         // (terminated),                                    
		.hdcp_i2c_wr          (1'b0),                                                                                         // (terminated),                                    
		.hdcp_i2c_rd          (1'b0),                                                                                         // (terminated),                                    
		.hdcp_i2c_addr        (8'b00000000),                                                                                  // (terminated),                                    
		.hdcp_i2c_wrdata      (8'b00000000),                                                                                  // (terminated),                                    
		.hdcp_i2c_rddata      (),                                                                                             // (terminated),                                    
		.rpt_msg_wr           (1'b0),                                                                                         // (terminated),                                    
		.rpt_msg_rd           (1'b0),                                                                                         // (terminated),                                    
		.rpt_msg_addr         (8'b00000000),                                                                                  // (terminated),                                    
		.rpt_msg_wrdata       (32'b00000000000000000000000000000000),                                                         // (terminated),                                    
		.rpt_msg_rddata       (),                                                                                             // (terminated),                                    
		.kmem_rdaddr          (),                                                                                             // (terminated),                                    
		.kmem_q               (88'b0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000), // (terminated),                                    
		.kmem_wait            (2'b00),                                                                                        // (terminated),                                    
		.hdcp1_enabled        (),                                                                                             // (terminated),                                    
		.hdcp2_enabled        (),                                                                                             // (terminated),                                    
		.streamid_type        ()                                                                                              // (terminated),                                    
	);

endmodule
