// (C) 2001-2020 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.



`timescale 1 ps / 1 ps
module hdmi_tx_altera_hdmi_1940_6fo3rly #(
   parameter FAMILY                = "Stratix 10",
   parameter SYMBOLS_PER_CLOCK     = 2,
   parameter ENABLE_FAST_ALIGNMENT = 0,
   parameter SUPPORT_AUXILIARY     = 1,
   parameter SUPPORT_DEEP_COLOR    = 1,
   parameter SUPPORT_AUDIO         = 1,
   parameter SUPPORT_32CHAN_AUDIO  = 0,
   parameter SUPPORT_HDCP1X        = 0,
   parameter SUPPORT_HDCP2X        = 0,
   parameter PIXELS_PER_CLOCK      = 2,
   parameter SYMBOLS_PER_CLOCK_20  = 2,
   parameter SYMBOLS_PER_CLOCK_21  = 2,
   parameter SYMBOLS_PER_CLOCK_FRL = 16,
   parameter SUPPORT_FRL           = 0,
   parameter TRANSCEIVER_WIDTH     = 20 
)(
   input  wire                                     reset,
   input  wire                                     reset_vid,
   input  wire                                     vid_clk,
   input  wire                                     ls_clk,
   input  wire                                     mode,
   input  wire [(1*SYMBOLS_PER_CLOCK)-1:0]         vid_de,
   input  wire [(48*SYMBOLS_PER_CLOCK)-1:0]        vid_data,
   input  wire [(1*SYMBOLS_PER_CLOCK)-1:0]         vid_hsync,
   input  wire [(1*SYMBOLS_PER_CLOCK)-1:0]         vid_vsync,
   output wire                                     aux_ready,
   input  wire                                     aux_valid,
   input  wire [71:0]                              aux_data, 
   input  wire                                     aux_sop,
   input  wire                                     aux_eop,
   input  wire [5:0]                               gcp,
   input  wire [112:0]                             info_avi,
   input  wire [61:0]                              info_vsi,
   input  wire                                     audio_clk,
   input  wire [19:0]                              audio_CTS,
   input  wire [19:0]                              audio_N,
   input  wire [255:0]                             audio_data,
   input  wire                                     audio_de,
   input  wire                                     audio_mute,
   input  wire [48:0]                              audio_info_ai,
   input  wire [165:0]                             audio_metadata,
   input  wire [4:0]                               audio_format,
   input  wire                                     hdcp_reset,
   input  wire                                     csr_clk,
   input  wire                                     crypto_clk,
   input  wire                                     csr_wr,
   input  wire                                     csr_rd,
   input  wire [7:0]                               csr_addr,
   input  wire [31:0]                              csr_wrdata,
   output wire [31:0]                              csr_rddata,
   output wire                                     hdcp1_enabled,
   output wire                                     hdcp2_enabled,
   output wire [9:0]                               kmem_rdaddr,
   input  wire [87:0]                              kmem_q,
   input  wire [1:0]                               kmem_wait,
   input  wire                                     Scrambler_Enable,
   input  wire                                     TMDS_Bit_clock_Ratio,
   input  wire [(6*SYMBOLS_PER_CLOCK)-1:0]         ctrl,
   output wire [(10*SYMBOLS_PER_CLOCK)-1:0]        out_b,
   output wire [(10*SYMBOLS_PER_CLOCK)-1:0]        out_r,
   output wire [(10*SYMBOLS_PER_CLOCK)-1:0]        out_g,
   output wire [(10*SYMBOLS_PER_CLOCK)-1:0]        out_c
);


   bitec_hdmi_tx #(
      .SUPPORT_HDCP1X       (SUPPORT_HDCP1X),
      .SUPPORT_HDCP2X       (SUPPORT_HDCP2X),
      .SYMBOLS_PER_CLOCK    (SYMBOLS_PER_CLOCK),
      .SUPPORT_AUXILIARY    (SUPPORT_AUXILIARY),
      .SUPPORT_DEEP_COLOR   (SUPPORT_DEEP_COLOR),
      .SUPPORT_AUDIO        (SUPPORT_AUDIO),
      .SUPPORT_32CHAN_AUDIO (SUPPORT_32CHAN_AUDIO)
   ) u_bitec_hdmi_tx (
      .reset                  (reset),
      .reset_vid              (reset_vid),
      .vid_clk                (vid_clk),
      .ls_clk                 (ls_clk),
      .mode                   (mode),
      .vid_de                 (vid_de),
      .vid_data               (vid_data),
      .vid_hsync              (vid_hsync),
      .vid_vsync              (vid_vsync),
      .out_b                  (out_b),
      .out_r                  (out_r),
      .out_g                  (out_g),
      .out_c                  (out_c),
      .aux_ready              (aux_ready),
      .aux_valid              (aux_valid),
      .aux_data               (aux_data),
      .aux_sop                (aux_sop),
      .aux_eop                (aux_eop),
      .gcp                    (gcp),
      .info_avi               (info_avi),
      .info_vsi               (info_vsi),
      .audio_clk              (audio_clk),
      .audio_CTS              (audio_CTS),
      .audio_N                (audio_N),
      .audio_data             (audio_data),
      .audio_de               (audio_de),
      .audio_mute             (audio_mute),
      .audio_info_ai          (audio_info_ai),
      .audio_metadata         (audio_metadata),
      .audio_format           (audio_format),
      .vde_to_hdcp            (),
      .vdata_to_hdcp          (),
      .ade_to_hdcp            (),
      .adata_to_hdcp          (),
      .hsync_to_hdcp          (),
      .vsync_to_hdcp          (),
      .ctl_to_hdcp            (),
      .vde_from_hdcp          ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .vdata_from_hdcp        ({SYMBOLS_PER_CLOCK*24{1'b0}}),
      .ade_from_hdcp          ({SYMBOLS_PER_CLOCK* 1{1'b0}}),
      .adata_from_hdcp        ({SYMBOLS_PER_CLOCK*12{1'b0}}),
      .ctl_from_hdcp          ({SYMBOLS_PER_CLOCK* 6{1'b0}}),
      .hdcp_enable            (1'b0),
      .set_avmute_to_hdcp     (),
      .clear_avmute_to_hdcp   (),
      .Scrambler_Enable       (Scrambler_Enable),
      .TMDS_Bit_clock_Ratio   (TMDS_Bit_clock_Ratio),
      .ctrl                   (ctrl),
      .version                ()
   );

   assign hdcp1_enabled = 1'b0;
   assign hdcp2_enabled = 1'b0;
   assign kmem_rdaddr   = 10'b0;
   assign csr_rddata    = 32'b0;

endmodule

