	component gxb_rx is
		port (
			rx_analogreset            : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_analogreset
			rx_digitalreset           : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_digitalreset
			rx_analogreset_stat       : out std_logic_vector(2 downto 0);                      -- rx_analogreset_stat
			rx_digitalreset_stat      : out std_logic_vector(2 downto 0);                      -- rx_digitalreset_stat
			rx_cal_busy               : out std_logic_vector(2 downto 0);                      -- rx_cal_busy
			rx_cdr_refclk0            : in  std_logic                      := 'X';             -- clk
			rx_serial_data            : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_serial_data
			rx_set_locktodata         : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_set_locktodata
			rx_set_locktoref          : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_set_locktoref
			rx_is_lockedtoref         : out std_logic_vector(2 downto 0);                      -- rx_is_lockedtoref
			rx_is_lockedtodata        : out std_logic_vector(2 downto 0);                      -- rx_is_lockedtodata
			rx_coreclkin              : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- clk
			rx_clkout                 : out std_logic_vector(2 downto 0);                      -- clk
			rx_parallel_data          : out std_logic_vector(59 downto 0);                     -- rx_parallel_data
			rx_syncstatus             : out std_logic_vector(5 downto 0);                      -- rx_syncstatus
			rx_patterndetect          : out std_logic_vector(5 downto 0);                      -- rx_patterndetect
			unused_rx_parallel_data   : out std_logic_vector(167 downto 0);                    -- unused_rx_parallel_data
			rx_polinv                 : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_polinv
			rx_std_bitslipboundarysel : out std_logic_vector(14 downto 0);                     -- rx_std_bitslipboundarysel
			rx_std_wa_patternalign    : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- rx_std_wa_patternalign
			reconfig_clk              : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- clk
			reconfig_reset            : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- reset
			reconfig_write            : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- write
			reconfig_read             : in  std_logic_vector(2 downto 0)   := (others => 'X'); -- read
			reconfig_address          : in  std_logic_vector(32 downto 0)  := (others => 'X'); -- address
			reconfig_writedata        : in  std_logic_vector(95 downto 0)  := (others => 'X'); -- writedata
			reconfig_readdata         : out std_logic_vector(95 downto 0);                     -- readdata
			reconfig_waitrequest      : out std_logic_vector(2 downto 0)                       -- waitrequest
		);
	end component gxb_rx;

	u0 : component gxb_rx
		port map (
			rx_analogreset            => CONNECTED_TO_rx_analogreset,            --            rx_analogreset.rx_analogreset
			rx_digitalreset           => CONNECTED_TO_rx_digitalreset,           --           rx_digitalreset.rx_digitalreset
			rx_analogreset_stat       => CONNECTED_TO_rx_analogreset_stat,       --       rx_analogreset_stat.rx_analogreset_stat
			rx_digitalreset_stat      => CONNECTED_TO_rx_digitalreset_stat,      --      rx_digitalreset_stat.rx_digitalreset_stat
			rx_cal_busy               => CONNECTED_TO_rx_cal_busy,               --               rx_cal_busy.rx_cal_busy
			rx_cdr_refclk0            => CONNECTED_TO_rx_cdr_refclk0,            --            rx_cdr_refclk0.clk
			rx_serial_data            => CONNECTED_TO_rx_serial_data,            --            rx_serial_data.rx_serial_data
			rx_set_locktodata         => CONNECTED_TO_rx_set_locktodata,         --         rx_set_locktodata.rx_set_locktodata
			rx_set_locktoref          => CONNECTED_TO_rx_set_locktoref,          --          rx_set_locktoref.rx_set_locktoref
			rx_is_lockedtoref         => CONNECTED_TO_rx_is_lockedtoref,         --         rx_is_lockedtoref.rx_is_lockedtoref
			rx_is_lockedtodata        => CONNECTED_TO_rx_is_lockedtodata,        --        rx_is_lockedtodata.rx_is_lockedtodata
			rx_coreclkin              => CONNECTED_TO_rx_coreclkin,              --              rx_coreclkin.clk
			rx_clkout                 => CONNECTED_TO_rx_clkout,                 --                 rx_clkout.clk
			rx_parallel_data          => CONNECTED_TO_rx_parallel_data,          --          rx_parallel_data.rx_parallel_data
			rx_syncstatus             => CONNECTED_TO_rx_syncstatus,             --             rx_syncstatus.rx_syncstatus
			rx_patterndetect          => CONNECTED_TO_rx_patterndetect,          --          rx_patterndetect.rx_patterndetect
			unused_rx_parallel_data   => CONNECTED_TO_unused_rx_parallel_data,   --   unused_rx_parallel_data.unused_rx_parallel_data
			rx_polinv                 => CONNECTED_TO_rx_polinv,                 --                 rx_polinv.rx_polinv
			rx_std_bitslipboundarysel => CONNECTED_TO_rx_std_bitslipboundarysel, -- rx_std_bitslipboundarysel.rx_std_bitslipboundarysel
			rx_std_wa_patternalign    => CONNECTED_TO_rx_std_wa_patternalign,    --    rx_std_wa_patternalign.rx_std_wa_patternalign
			reconfig_clk              => CONNECTED_TO_reconfig_clk,              --              reconfig_clk.clk
			reconfig_reset            => CONNECTED_TO_reconfig_reset,            --            reconfig_reset.reset
			reconfig_write            => CONNECTED_TO_reconfig_write,            --             reconfig_avmm.write
			reconfig_read             => CONNECTED_TO_reconfig_read,             --                          .read
			reconfig_address          => CONNECTED_TO_reconfig_address,          --                          .address
			reconfig_writedata        => CONNECTED_TO_reconfig_writedata,        --                          .writedata
			reconfig_readdata         => CONNECTED_TO_reconfig_readdata,         --                          .readdata
			reconfig_waitrequest      => CONNECTED_TO_reconfig_waitrequest       --                          .waitrequest
		);

