// hdmi_tx.v

// Generated using ACDS version 20.2 50

`timescale 1 ps / 1 ps
module hdmi_tx (
		input  wire         reset,                //                reset.export
		input  wire         reset_vid,            //            reset_vid.export
		input  wire         vid_clk,              //              vid_clk.export
		input  wire         ls_clk,               //               ls_clk.export
		input  wire         mode,                 //                 mode.export
		input  wire [1:0]   vid_de,               //               vid_de.export
		input  wire [95:0]  vid_data,             //             vid_data.export
		input  wire [1:0]   vid_hsync,            //            vid_hsync.export
		input  wire [1:0]   vid_vsync,            //            vid_vsync.export
		output wire [19:0]  out_b,                //                out_b.export
		output wire [19:0]  out_r,                //                out_r.export
		output wire [19:0]  out_g,                //                out_g.export
		output wire [19:0]  out_c,                //                out_c.export
		output wire         aux_ready,            //            aux_ready.export
		input  wire         aux_valid,            //            aux_valid.export
		input  wire [71:0]  aux_data,             //             aux_data.export
		input  wire         aux_sop,              //              aux_sop.export
		input  wire         aux_eop,              //              aux_eop.export
		input  wire [5:0]   gcp,                  //                  gcp.export
		input  wire [112:0] info_avi,             //             info_avi.export
		input  wire [61:0]  info_vsi,             //             info_vsi.export
		input  wire         audio_clk,            //            audio_clk.clk
		input  wire [19:0]  audio_CTS,            //            audio_CTS.export
		input  wire [19:0]  audio_N,              //              audio_N.export
		input  wire [255:0] audio_data,           //           audio_data.export
		input  wire         audio_de,             //             audio_de.export
		input  wire         audio_mute,           //           audio_mute.export
		input  wire [48:0]  audio_info_ai,        //        audio_info_ai.export
		input  wire [165:0] audio_metadata,       //       audio_metadata.export
		input  wire [4:0]   audio_format,         //         audio_format.export
		input  wire         Scrambler_Enable,     //     Scrambler_Enable.export
		input  wire         TMDS_Bit_clock_Ratio, // TMDS_Bit_clock_Ratio.export
		input  wire [11:0]  ctrl                  //                 ctrl.export
	);

	hdmi_tx_altera_hdmi_1940_6fo3rly #(
		.FAMILY                ("Stratix 10"),
		.SYMBOLS_PER_CLOCK     (2),
		.PIXELS_PER_CLOCK      (2),
		.TRANSCEIVER_WIDTH     (20),
		.ENABLE_FAST_ALIGNMENT (0),
		.SUPPORT_AUXILIARY     (1),
		.SUPPORT_DEEP_COLOR    (1),
		.SUPPORT_AUDIO         (1),
		.SUPPORT_32CHAN_AUDIO  (0),
		.SUPPORT_FRL           (0),
		.SYMBOLS_PER_CLOCK_20  (2),
		.SYMBOLS_PER_CLOCK_21  (2),
		.SYMBOLS_PER_CLOCK_FRL (16)
	) hdmi_tx (
		.reset                (reset),                                                                                        //   input,    width = 1,                reset.export
		.reset_vid            (reset_vid),                                                                                    //   input,    width = 1,            reset_vid.export
		.vid_clk              (vid_clk),                                                                                      //   input,    width = 1,              vid_clk.export
		.ls_clk               (ls_clk),                                                                                       //   input,    width = 1,               ls_clk.export
		.mode                 (mode),                                                                                         //   input,    width = 1,                 mode.export
		.vid_de               (vid_de),                                                                                       //   input,    width = 2,               vid_de.export
		.vid_data             (vid_data),                                                                                     //   input,   width = 96,             vid_data.export
		.vid_hsync            (vid_hsync),                                                                                    //   input,    width = 2,            vid_hsync.export
		.vid_vsync            (vid_vsync),                                                                                    //   input,    width = 2,            vid_vsync.export
		.out_b                (out_b),                                                                                        //  output,   width = 20,                out_b.export
		.out_r                (out_r),                                                                                        //  output,   width = 20,                out_r.export
		.out_g                (out_g),                                                                                        //  output,   width = 20,                out_g.export
		.out_c                (out_c),                                                                                        //  output,   width = 20,                out_c.export
		.aux_ready            (aux_ready),                                                                                    //  output,    width = 1,            aux_ready.export
		.aux_valid            (aux_valid),                                                                                    //   input,    width = 1,            aux_valid.export
		.aux_data             (aux_data),                                                                                     //   input,   width = 72,             aux_data.export
		.aux_sop              (aux_sop),                                                                                      //   input,    width = 1,              aux_sop.export
		.aux_eop              (aux_eop),                                                                                      //   input,    width = 1,              aux_eop.export
		.gcp                  (gcp),                                                                                          //   input,    width = 6,                  gcp.export
		.info_avi             (info_avi),                                                                                     //   input,  width = 113,             info_avi.export
		.info_vsi             (info_vsi),                                                                                     //   input,   width = 62,             info_vsi.export
		.audio_clk            (audio_clk),                                                                                    //   input,    width = 1,            audio_clk.clk
		.audio_CTS            (audio_CTS),                                                                                    //   input,   width = 20,            audio_CTS.export
		.audio_N              (audio_N),                                                                                      //   input,   width = 20,              audio_N.export
		.audio_data           (audio_data),                                                                                   //   input,  width = 256,           audio_data.export
		.audio_de             (audio_de),                                                                                     //   input,    width = 1,             audio_de.export
		.audio_mute           (audio_mute),                                                                                   //   input,    width = 1,           audio_mute.export
		.audio_info_ai        (audio_info_ai),                                                                                //   input,   width = 49,        audio_info_ai.export
		.audio_metadata       (audio_metadata),                                                                               //   input,  width = 166,       audio_metadata.export
		.audio_format         (audio_format),                                                                                 //   input,    width = 5,         audio_format.export
		.Scrambler_Enable     (Scrambler_Enable),                                                                             //   input,    width = 1,     Scrambler_Enable.export
		.TMDS_Bit_clock_Ratio (TMDS_Bit_clock_Ratio),                                                                         //   input,    width = 1, TMDS_Bit_clock_Ratio.export
		.ctrl                 (ctrl),                                                                                         //   input,   width = 12,                 ctrl.export
		.hdcp_reset           (1'b0),                                                                                         // (terminated),                                    
		.csr_clk              (1'b0),                                                                                         // (terminated),                                    
		.crypto_clk           (1'b0),                                                                                         // (terminated),                                    
		.csr_wr               (1'b0),                                                                                         // (terminated),                                    
		.csr_rd               (1'b0),                                                                                         // (terminated),                                    
		.csr_addr             (8'b00000000),                                                                                  // (terminated),                                    
		.csr_wrdata           (32'b00000000000000000000000000000000),                                                         // (terminated),                                    
		.csr_rddata           (),                                                                                             // (terminated),                                    
		.kmem_rdaddr          (),                                                                                             // (terminated),                                    
		.kmem_q               (88'b0000000000000000000000000000000000000000000000000000000000000000000000000000000000000000), // (terminated),                                    
		.kmem_wait            (2'b00),                                                                                        // (terminated),                                    
		.hdcp1_enabled        (),                                                                                             // (terminated),                                    
		.hdcp2_enabled        ()                                                                                              // (terminated),                                    
	);

endmodule
