# (C) 2001-2018 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.





# From Timequest cookbook

derive_clock_uncertainty

set CLK_STATUS      [get_clocks clk_status]
set RECONFIG_CLK    [get_clocks reconfig_clk]
### Add following when RX_PLL_TYPE is visible
# if {$rx_pll_type == "FPLL"} {
#set RX_CORECLK      [get_clock_info -name [get_clocks av_top|alt_e40_0|FPLL_inst.rx_pll|s10_fpll_rx_outclk_div1]]
# } else {
#set RX_CORECLK      [get_clock_info -name [get_clocks av_top|alt_e40_0|IOPLL_inst.rx_pll|s10_iopll_rx_outclk0 ]]
# }


set RX_CORECLK      [get_clock_info -name [get_clocks av_top|alt_e40_0|IOPLL_inst.rx_pll|s10_iopll_rx_outclk0 ]]

set IOPLL_LOCKCLK   [get_clock_info -name [get_clocks av_top|alt_e40_0|pma_40g|s10_native_phy|rx_clkout|ch0 ]]
set IOPLL_REFCLK    $IOPLL_LOCKCLK 


set TX_CORECLK      [get_clock_info -name [get_clocks av_top|alt_e40_0|tx_pll_gen.tx_pll|clkdiv_output_div1]]

if {$::TimeQuestInfo(nameofexecutable) eq "quartus_fit"} {
   # fitter; 15% at 312.5MHz
   set_clock_uncertainty -setup -add -from $RX_CORECLK 0.48
   set_clock_uncertainty -setup -add -from $TX_CORECLK 0.48
} else {
   # everywhere else
}

set  clock_group_rx [list ]
lappend clock_group_rx $RX_CORECLK 
lappend clock_group_rx $IOPLL_LOCKCLK

set  clock_group_tx [list ]
lappend clock_group_tx $TX_CORECLK 

set_clock_groups -asynchronous -group $RECONFIG_CLK -group $clock_group_rx  -group  $clock_group_tx 
set_clock_groups -asynchronous -group $CLK_STATUS 

set_false_path -from av_top|alt_e40_0|pma_40g|s10_native_phy|s10_xcvr_10g_4channel|g_non_hip_reset.alt_xcvr_native_reset_seq|g_trs.tx_dig_reset_seq|reset_out_stage[*] -to av_top|alt_e40_0|pma_40g|WR_EN_GEN[*].stat_synchronizer_inst|sync[*].synchronizer_nocut_inst|din_s1 
set_false_path -from av_top|alt_e40_0|pma_40g|s10_native_phy|s10_xcvr_10g_4channel|g_non_hip_reset.alt_xcvr_native_reset_seq|g_trs.tx_dig_reset_seq|reset_out_stage[*] -to av_top|alt_e40_0|eth_core|reset_controler|sync_tx_digitalreset|synchronizer_nocut_inst* 

set_multicycle_path -from $IOPLL_REFCLK -to $RX_CORECLK -setup 5 -end
set_multicycle_path -from $IOPLL_REFCLK -to $RX_CORECLK -hold 4 -end

if {! [is_post_route]} {
 set_max_delay -from *dcm.reg  2ns
}


