// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1ps/1ps
module alt_eth_40g (
    input wire  clk_status,
    input wire  status_write,
    input wire  status_read,
    input wire [15:0] status_addr,
    input wire [31:0] status_writedata,
    output wire [31:0] status_readdata,
    output wire  status_readdata_valid,
    output wire  status_waitrequest,
    output wire  clk_txmac,
    input wire  l2_tx_startofpacket,
    input wire  l2_tx_error,
    input wire  l2_tx_endofpacket,
    input wire  l2_tx_valid,
    output wire  l2_tx_ready,
    input wire [3:0] l2_tx_empty,
    input wire [127:0] l2_tx_data,
    output wire  clk_rxmac,
    output wire [5:0] l2_rx_error,
    output wire  l2_rx_valid,
    output wire  l2_rx_startofpacket,
    output wire  l2_rx_endofpacket,
    output wire [3:0] l2_rx_empty,
    output wire [127:0] l2_rx_data,
    output wire [3:0] tx_serial,
    input wire [3:0] rx_serial,
    input wire  reconfig_clk,
    input wire  reconfig_reset,
    input wire  reconfig_write,
    input wire  reconfig_read,
    input wire [12:0] reconfig_address,
    input wire [31:0] reconfig_writedata,
    output wire [31:0] reconfig_readdata,
    output wire  reconfig_waitrequest,
    output wire  tx_lanes_stable,
    output wire  rx_pcs_ready,
    input wire  clk_ref,
    input wire  csr_rst_n,
    input wire  tx_rst_n,
    input wire  rx_rst_n,
    output wire  rx_block_lock,
    output wire  rx_am_lock,
    output wire  l2_txstatus_valid,
    output wire [39:0] l2_txstatus_data,
    output wire [6:0] l2_txstatus_error,
    output wire  l2_rxstatus_valid,
    output wire [39:0] l2_rxstatus_data
);

    wire tx_serial_clk;
    wire tx_pll_locked;

    s10_atx_pll atx (
        .pll_refclk0    (clk_ref),
        .tx_serial_clk  (tx_serial_clk),
        .pll_locked     (tx_pll_locked),
        .pll_cal_busy   ()
    );


    ex_40g_s10 av_top (
        .clk_status(clk_status),
        .status_write(status_write),
        .status_read(status_read),
        .status_addr(status_addr),
        .status_writedata(status_writedata),
        .status_readdata(status_readdata),
        .status_readdata_valid(status_readdata_valid),
        .status_waitrequest(status_waitrequest),
        .clk_txmac(clk_txmac),
        .l2_tx_startofpacket(l2_tx_startofpacket),
        .l2_tx_error(l2_tx_error),
        .l2_tx_endofpacket(l2_tx_endofpacket),
        .l2_tx_valid(l2_tx_valid),
        .l2_tx_ready(l2_tx_ready),
        .l2_tx_empty(l2_tx_empty),
        .l2_tx_data(l2_tx_data),
        .clk_rxmac(clk_rxmac),
        .l2_rx_error(l2_rx_error),
        .l2_rx_valid(l2_rx_valid),
        .l2_rx_startofpacket(l2_rx_startofpacket),
        .l2_rx_endofpacket(l2_rx_endofpacket),
        .l2_rx_empty(l2_rx_empty),
        .l2_rx_data(l2_rx_data),
        .tx_serial(tx_serial),
        .rx_serial(rx_serial),
        .reconfig_clk(reconfig_clk),
        .reconfig_reset(reconfig_reset),
        .reconfig_write(reconfig_write),
        .reconfig_read(reconfig_read),
        .reconfig_address(reconfig_address),
        .reconfig_writedata(reconfig_writedata),
        .reconfig_readdata(reconfig_readdata),
        .reconfig_waitrequest(reconfig_waitrequest),
        .tx_lanes_stable(tx_lanes_stable),
        .rx_pcs_ready(rx_pcs_ready),
        .clk_ref(clk_ref),
        .csr_rst_n(csr_rst_n),
        .tx_rst_n(tx_rst_n),
        .rx_rst_n(rx_rst_n),
        .rx_block_lock(rx_block_lock),
        .rx_am_lock(rx_am_lock),
        .l2_txstatus_valid(l2_txstatus_valid),
        .l2_txstatus_data(l2_txstatus_data),
        .l2_txstatus_error(l2_txstatus_error),
        .l2_rxstatus_valid(l2_rxstatus_valid),
        .l2_rxstatus_data(l2_rxstatus_data),
        .tx_serial_clk(tx_serial_clk),
        .tx_pll_locked(tx_pll_locked)
    );
endmodule

