// (C) 2001-2018 Intel Corporation. All rights reserved.
// Your use of Intel Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files from any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Intel Program License Subscription 
// Agreement, Intel FPGA IP License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Intel and sold by 
// Intel or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


`timescale 1 ps / 1 ps

(* altera_attribute = "-name message_disable 13410"*)


//`define ENABLE_DDR4A
//`define ENABLE_DDR4B
//`define ENABLE_DDR4C
//`define ENABLE_DDR4D
//`define ENABLE_PCIE
`define ENABLE_QSFP28A
//`define ENABLE_QSFP28B
//`define ENABLE_QSFP28C
//`define ENABLE_QSFP28D
//`define ENABLE_HPS
`define ENABLE_FMCP

module eth_ex_40g #(
    parameter SIM_HURRY = 1'b0,
    parameter SIM_EMULATE = 1'b0
) (

      ///////// CLOCK /////////
      input              CLK_100_B3I,
      input              CLK_50_B2F,
      input              CLK_50_B2L,
      input              CLK_50_B3C,
      input              CLK_50_B3I,
      input              LVDS_REFCLK_p,

      ///////// Buttons /////////
      input              CPU_RESET_n,
      input    [ 1: 0]   BUTTON,

      ///////// Swtiches /////////
      input    [ 1: 0]   SW,

      ///////// LED /////////
      output   [ 1: 0]   LED, //LED is Low-Active

`ifdef ENABLE_DDR4A
      ///////// DDR4A /////////
      input              DDR4A_REFCLK_p,
      output   [17: 0]   DDR4A_A,
      output   [ 1: 0]   DDR4A_BA,
      output   [ 1: 0]   DDR4A_BG,
      output             DDR4A_CK,
      output             DDR4A_CK_n,
      output   [ 1: 0]   DDR4A_CKE,
      inout    [ 8: 0]   DDR4A_DQS,
      inout    [ 8: 0]   DDR4A_DQS_n,
      inout    [71: 0]   DDR4A_DQ,
      inout    [ 8: 0]   DDR4A_DBI_n,
      output   [ 1: 0]   DDR4A_CS_n,
      output             DDR4A_RESET_n,
      output   [ 1: 0]   DDR4A_ODT,
      output             DDR4A_PAR,
      input              DDR4A_ALERT_n,
      output             DDR4A_ACT_n,
      input              DDR4A_RZQ,
`endif /*ENABLE_DDR4A*/

`ifdef ENABLE_DDR4B
      ///////// DDR4B /////////
      input              DDR4B_REFCLK_p,
      output   [17: 0]   DDR4B_A,
      output   [ 1: 0]   DDR4B_BA,
      output   [ 1: 0]   DDR4B_BG,
      output             DDR4B_CK,
      output             DDR4B_CK_n,
      output   [ 1: 0]   DDR4B_CKE,
      inout    [ 8: 0]   DDR4B_DQS,
      inout    [ 8: 0]   DDR4B_DQS_n,
      inout    [71: 0]   DDR4B_DQ,
      inout    [ 8: 0]   DDR4B_DBI_n,
      output   [ 1: 0]   DDR4B_CS_n,
      output             DDR4B_RESET_n,
      output   [ 1: 0]   DDR4B_ODT,
      output             DDR4B_PAR,
      input              DDR4B_ALERT_n,
      output             DDR4B_ACT_n,
      input              DDR4B_RZQ,
`endif /*ENABLE_DDR4B*/

      ///////// SI5341A /////////
      inout              SI5341A_I2C_SCL,
      inout              SI5341A_I2C_SDA,
      output             SI5341A_OE_n,
      output             SI5341A_RST_n,

`ifdef ENABLE_FMC
      ///////// FMC /////////
      input    [ 1: 0]   S10C_KEY,
      input    [ 1: 0]   S10C_SW,
      output   [ 3: 0]   S10C_LED,
      inout    [35: 0]   FMC_GPIO_D,
`endif /*ENABLE_FMC*/

`ifdef ENABLE_FMCP
      ///////// FMCP /////////
      input              FMCP_REFCLK_p,
      inout              Si5340A_I2C_SCL,                    // FMCP_SCL
      inout              Si5340A_I2C_SDA,                    // FMCP_SDA
      output             SI5340A_OE_n,
      output             SI5340A_RST_n,

`ifdef ENABLE_PCIE        
      input              DG_PCIe_RST_n,
      output             DG_PEWAKE_n_FMCP,
      input              DG_PM_S0_EN_FMCP,
      input              DG_PM_S3_EN_FMCP,
      input              PCIE_REFCLK_p,
      input    [ 3: 0]   PCIE_RX_p,
      output   [ 3: 0]   PCIE_TX_p,
`endif /*ENABLE_PCIE*/

`ifdef ENABLE_QSFP28A
      input              QSFP28A_INTERRUPT_n,
      output             QSFP28A_LP_MODE,
      input              QSFP28A_MOD_PRS_n,
      output             QSFP28A_MOD_SEL_n,
      output             QSFP28A_RST_n,
      inout              QSFP28A_SCL,
      inout              QSFP28A_SDA,
      input              QSFP28A_REFCLK_p,
      input    [ 3: 0]   QSFP28A_RX_p,
      output   [ 3: 0]   QSFP28A_TX_p,
`endif /*ENABLE_QSFP28A*/

`ifdef ENABLE_QSFP28B
      input              QSFP28B_INTERRUPT_n,
      output             QSFP28B_LP_MODE,
      input              QSFP28B_MOD_PRS_n,
      output             QSFP28B_MOD_SEL_n,
      output             QSFP28B_RST_n,
      inout              QSFP28B_SCL,
      inout              QSFP28B_SDA,
      input              QSFP28B_REFCLK_p,
      input    [ 3: 0]   QSFP28B_RX_p,
      output   [ 3: 0]   QSFP28B_TX_p,
`endif /*ENABLE_QSFP28B*/
`endif /*ENABLE_FMCP*/

`ifdef ENABLE_HPS
      ///////// HPS /////////
      output             HPS_ENET_MDC,
      inout              HPS_ENET_MDIO,
      input              HPS_ENET_RX_CLK,
      input              HPS_ENET_RX_CTL,
      input    [ 3: 0]   HPS_ENET_RX_DATA,
      output             HPS_ENET_TX_CLK,
      output             HPS_ENET_TX_CTL,
      output   [ 3: 0]   HPS_ENET_TX_DATA,
      inout    [ 3: 0]   HPS_GPIO,
      inout              HPS_I2C_SCL,
      inout              HPS_I2C_SDA,
      inout              HPS_KEY,
      inout              HPS_LED,
      input              HPS_OSC_CLK,
      output             HPS_SD_CLK,
      inout              HPS_SD_CMD,
      inout    [ 3: 0]   HPS_SD_DATA,
      input              HPS_UART_RX,
      output             HPS_UART_TX,
      input              HPS_USB_CLK,
      inout    [ 7: 0]   HPS_USB_DATA,
      input              HPS_USB_DIR,
      input              HPS_USB_NXT,
      output             HPS_USB_STP,
`endif /*ENABLE_HPS*/

      ///////// S10MAX10 /////////
      output             INFO_SPI_SCLK, 
      output             INFO_SPI_CS_n, 
      output             INFO_SPI_MOSI, 
      input              INFO_SPI_MISO 


/*
    input       clk50,
    input       cpu_resetn,

    output      qsfp_rstn,
    output      qsfp_lowpwr,

    input wire  clk_ref,
    input wire  [3:0] rx_serial,
    output wire [3:0] tx_serial,
//    output wire [9:0] user_io,
    output wire [7:0] user_led */

  );
  
assign SI5340A_OE_n = 0; 
assign SI5340A_RST_n = 1;
  
  ///////////////////////////
// pin connection
wire 			clk50;  
wire 			cpu_resetn;
wire [7:0]	user_led;

wire	      qsfp_rstn;
wire		   qsfp_lowpwr;
wire		   clk_ref;
wire	[3:0] rx_serial;
wire  [3:0] tx_serial;

assign clk50 = CLK_50_B2L;
assign cpu_resetn = CPU_RESET_n;
assign LED = user_led[3:0];

  
`ifdef ENABLE_QSFP28A
	assign QSFP28A_RST_n = qsfp_rstn;
	assign QSFP28A_LP_MODE = qsfp_lowpwr;
	assign clk_ref = QSFP28A_REFCLK_p;
	assign QSFP28A_TX_p = tx_serial;
	assign rx_serial = QSFP28A_RX_p;
`endif // ENABLE_QSFP28A  

`ifdef ENABLE_QSFP28B
	assign QSFP28B_RST_n = qsfp_rstn;
	assign QSFP28B_LP_MODE = qsfp_lowpwr;
	assign clk_ref = QSFP28B_REFCLK_p;
	assign QSFP28B_TX_p = tx_serial;
	assign rx_serial = QSFP28B_RX_p;
`endif // ENABLE_QSFP28B  

`ifdef ENABLE_QSFP28C
	assign QSFP28C_RST_n = qsfp_rstn;
	assign QSFP28C_LP_MODE = qsfp_lowpwr;
	assign clk_ref = QSFP28C_REFCLK_p;
	assign QSFP28C_TX_p = tx_serial;
	assign rx_serial = QSFP28C_RX_p;
`endif // ENABLE_QSFP28C  

`ifdef ENABLE_QSFP28D
	assign QSFP28D_RST_n = qsfp_rstn;
	assign QSFP28D_LP_MODE = qsfp_lowpwr;
	assign clk_ref = QSFP28D_REFCLK_p;
	assign QSFP28D_TX_p = tx_serial;
	assign rx_serial = QSFP28D_RX_p;
`endif // ENABLE_QSFP28D  
  
  
//////////////////////////////
// SI5340A clock config for xcvr


assign SI5340A0_RST_n = 1'b1;
assign SI5340A1_RST_n = 1'b1;

assign SI5340A0_OE_n = 1'b0;
assign SI5340A1_OE_n = 1'b0; 

//////////////////////////////  

  

    assign qsfp_rstn    = 1'b1;
    assign qsfp_lowpwr  = 1'b0;

    reg [9:0] clk50_cnt = 10'b0;
    reg [9:0] clk100_cnt = 10'b0;
    reg [9:0] clk_txmac_cnt = 10'b0;
    reg [9:0] clk_rxmac_cnt = 10'b0;

    localparam DEVICE_FAMILY = "Stratix 10";
    localparam WORDS = 2;
    localparam WIDTH = 64;
    localparam SIM_NO_TEMP_SENSE = 1'b1;

    wire sys_pll_locked;
    wire clk100;



    alt_e40_sys_pll sys_pll (
        .rst        (~cpu_resetn),
        .refclk     (clk50),
        .locked     (sys_pll_locked),
        .outclk_0   (clk100)
    );

    wire sys_pll_locked_stretched;
    alt_e40_locklag5 rd0 (
        .clk    (clk100),
        .din    (sys_pll_locked),
        .dout   (sys_pll_locked_stretched)
    );
    defparam rd0 .SIM_HURRY = SIM_HURRY;
    defparam rd0 .SIM_EMULATE = SIM_EMULATE;

    wire    arst;
    wire    [7:0] source_reset;
    assign  arst = ~cpu_resetn | ~sys_pll_locked_stretched | source_reset[0];

    wire [15:0]     status_addr;
    wire            status_read,status_write,status_readdata_valid_eth;
    wire [31:0]     status_readdata_eth, status_writedata;
    wire            status_read_timeout = 0;
    wire            clk_status = clk100;
    wire            clk_txmac;
    wire            clk_rxmac;

    wire [127:0]    l2_tx_data;
    wire [3:0]      l2_tx_empty;
    wire            l2_tx_endofpacket;
    wire            l2_tx_ready;
    wire            l2_tx_startofpacket;
    wire            l2_tx_valid;
    wire [127:0]    l2_rx_data;
    wire [3:0]      l2_rx_empty;
    wire            l2_rx_endofpacket;
    wire            l2_rx_startofpacket;
    wire            l2_rx_valid;
    wire [5:0]      l2_rx_error;

    // map reconfig registers to 0x4000-0x7FFF
    wire        reco_waitrequest;
    wire        reco_readdata_valid;
    wire [31:0] reco_readdata;
    reg         status_read_r;
    reg         status_write_r;
    reg  [31:0] status_writedata_r;
    reg  [15:0] status_addr_r;
  
    always @(posedge clk_status) begin
        if (arst) begin
            status_read_r <= 0;
            status_write_r <= 0;
            status_writedata_r <= 32'b0;
            status_addr_r <= 16'b0;
        end
        else if( !reco_waitrequest ) begin
            status_read_r <= status_read;
            status_write_r <= status_write;
            status_writedata_r <= status_writedata;
            status_addr_r <= status_addr;
        end
    end
 
    wire        reco_cs    = ((status_addr_r >= 16'h4000) && (status_addr_r <= 16'h7FFF));
    wire        reco_read  = status_read_r  && reco_cs;
    wire        reco_write = status_write_r && reco_cs;
    wire [12:0] reco_addr = (reco_read || reco_write) ? status_addr_r[12:0] : 13'b0;
    assign      reco_readdata_valid = reco_read && !reco_waitrequest;
    wire        status_waitrequest;
    wire        rx_block_lock;
    wire        rx_am_lock;
    wire        rx_pcs_ready;
    wire        tx_lanes_stable;
    wire        tx_pll_locked;
//    wire        tx_serial_clk_gt;
    wire        tx_serial_clk ;


wire definetest;
`ifdef ALTERA_RESERVED_QIS
 assign definetest = clk50_cnt[5];
`else
 assign definetest = clk_txmac_cnt[5];
`endif


    s10_atx_pll atx (
        .pll_refclk0    (clk_ref),
        .tx_serial_clk  (tx_serial_clk),
        .pll_locked     (tx_pll_locked),
        .pll_cal_busy   ()
    );


    wire eth_cs    = ((status_addr >= 16'h0000) && (status_addr <= 16'h0DFF));
    wire eth_read  = (eth_cs && status_read);
    wire eth_write = (eth_cs && status_write);
    ex_40g_s10 av_top (
	//.loop_done		( source_reset[7]      ),
        .clk_ref                (clk_ref),
        .csr_rst_n              (~arst),
        .tx_rst_n               (1'b1),
        .rx_rst_n               (1'b1),
        .tx_serial_clk          (tx_serial_clk),
        .tx_pll_locked          (tx_pll_locked),
        .clk_status             (clk_status),
//        .reset_status           (1'b0),


        .rx_serial              (rx_serial),
        .tx_serial              (tx_serial),

        .status_write           (eth_write),
        .status_read            (eth_read),
        .status_addr            (status_addr),
        .status_writedata       (status_writedata),
        .status_readdata        (status_readdata_eth),
        .status_readdata_valid  (status_readdata_valid_eth),
        .status_waitrequest     (), // NOT USE DUT WAITREQUEST?

        .clk_txmac              (clk_txmac),
        .l2_tx_startofpacket    (l2_tx_startofpacket),
        .l2_tx_endofpacket      (l2_tx_endofpacket),
        .l2_tx_valid            (l2_tx_valid),
        .l2_tx_ready            (l2_tx_ready),
        .l2_tx_empty            (l2_tx_empty),
        .l2_tx_data             (l2_tx_data),

        .tx_lanes_stable        (tx_lanes_stable),
        .rx_block_lock          (rx_block_lock),
        .rx_am_lock             (rx_am_lock),
        .rx_pcs_ready           (rx_pcs_ready),
        .clk_rxmac              (clk_rxmac),

        .l2_txstatus_valid      (/* Unused */),    // 1  bits
        .l2_txstatus_data       (/* Unused */),    // 40 bits
        .l2_txstatus_error      (/* Unused */),    // 7  bits
        .l2_rxstatus_valid      (/* Unused */),    // 1  bits
        .l2_rxstatus_data       (/* Unused */),    // 40 bits

        .l2_rx_error            (l2_rx_error),
        .l2_rx_valid            (l2_rx_valid),
        .l2_rx_startofpacket    (l2_rx_startofpacket),
        .l2_rx_endofpacket      (l2_rx_endofpacket),
        .l2_rx_data             (l2_rx_data),
        .l2_rx_empty            (l2_rx_empty),




        .reconfig_clk           (clk_status),
        .reconfig_reset         (arst),
        .reconfig_write         (reco_write),
        .reconfig_read          (reco_read),
        .reconfig_address       (reco_addr),
        .reconfig_writedata     (status_writedata_r[31:0]),
        .reconfig_readdata      (reco_readdata[31:0]),
        .reconfig_waitrequest   (reco_waitrequest)
    );

    wire [31:0] status_readdata_pc;
    wire status_readdata_valid_pc;

    alt_e40_packet_client pc (
        .arst        (arst),
        
        // TX to Ethernet
        .clk_tx                 (clk_txmac),
        .tx_valid               (l2_tx_valid),
        .tx_ack                 (l2_tx_ready),
        .tx_data                (l2_tx_data),
        .tx_start               (l2_tx_startofpacket),
        .tx_end                 (l2_tx_endofpacket),
        .tx_empty               (l2_tx_empty),
        .tx_lanes_stable        (tx_lanes_stable),
        
        // RX from Ethernet
        .clk_rx                 (clk_rxmac),
        .rx_valid               (l2_rx_valid),
        .rx_data                (l2_rx_data),
        .rx_start               (l2_rx_startofpacket),
        .rx_end                 (l2_rx_endofpacket),
        .rx_empty               (l2_rx_empty),
        .rx_error               (l2_rx_error),
        
        .rx_block_lock          (rx_block_lock),
        .rx_am_lock             (rx_am_lock),
        .rx_pcs_ready           (rx_pcs_ready),
        // status register bus
        .clk_status             (clk_status),
        .status_addr            (status_addr),
        .status_read            (status_read),
        .status_write           (status_write),
        .status_writedata       (status_writedata),
        .status_readdata        (status_readdata_pc),
        .status_readdata_valid  (status_readdata_valid_pc)
    );
    defparam pc.WORDS = WORDS;
    defparam pc.WIDTH = WIDTH;
    defparam pc.SIM_NO_TEMP_SENSE= SIM_NO_TEMP_SENSE;
    defparam pc.DEVICE_FAMILY = DEVICE_FAMILY;

    // _____________________________________________________________
    // merge status bus
    // _____________________________________________________________

    wire [31:0] status_readdata;
    wire status_readdata_valid;
    reg  [2:0] client_readdata_valid;

    always @(*) begin
        if (status_readdata_valid_pc) client_readdata_valid = 3'b010;
        else if (reco_readdata_valid) client_readdata_valid = 3'b001;
        else client_readdata_valid = {status_readdata_valid_eth|status_read_timeout, 2'b00};
    end

    alt_e40_avmm_combine #(
        .NUM_CLIENTS            (3)
    ) arc (
        .clk                    (clk_status),
        .arst                   (arst),
        .host_read              (status_read),
        .host_readdata          (status_readdata),
        .host_readdata_valid    (status_readdata_valid),
        .host_waitrequest       (status_waitrequest),

        .client_readdata_valid  (client_readdata_valid),
        .client_readdata        ({status_readdata_eth,
                                  status_readdata_pc,
                                  reco_readdata})
    );

    // _______________________________________________________________________________________________________________ 
    // jtag_avalon 
    // _______________________________________________________________________________________________________________
    wire [31:0] av_addr;
    assign status_addr = av_addr[17:2];
    wire [3:0] byteenable;

    alt_e40_jtag_bridge jtag_bridge (
        .clk_clk              (clk_status),
        .clk_reset_reset      (arst),
        .master_address       (av_addr),
        .master_readdata      (status_readdata),
        .master_read          (status_read),
        .master_write         (status_write),
        .master_writedata     (status_writedata),
        .master_waitrequest   (status_waitrequest),
        .master_readdatavalid (status_readdata_valid),
        .master_byteenable    (byteenable),
        .master_reset_reset   ()
    );



    always @(posedge clk_rxmac) begin
	clk_rxmac_cnt <= clk_rxmac_cnt + 10'd1;
    end

    always @(posedge clk_txmac) begin
	clk_txmac_cnt <= clk_txmac_cnt + 10'd1;
    end

    always @(posedge clk50) begin
	clk50_cnt <= clk50_cnt + 10'd1;
    end

    always @(posedge clk100) begin
	clk100_cnt <= clk100_cnt + 10'd1;
    end


    // Clock dividers
    wire top_bit_clk50;
    div_230 #(
        .NBITS(10)
    ) div_clk50 (
        .clk(clk50),
        .rst(1'b0),
        .top_bit(top_bit_clk50)
    );

    wire top_bit_clk100;
    div_230 #(
        .NBITS(10)
    ) div_clk100 (
        .clk(clk100),
        .rst(1'b0),
        .top_bit(top_bit_clk100)
    );



    wire [7:0] system_status;

    assign system_status[0] = arst;
/*
    assign system_status[1] = top_bit_clkref;
    assign system_status[2] = top_bit_clk50;
    assign system_status[3] = top_bit_clk100;
*/
    assign system_status[1] = clk_txmac_cnt[5];
    assign system_status[2] = clk50_cnt[3];
    assign system_status[3] = clk_rxmac_cnt[5];

    assign system_status[4] = tx_lanes_stable;
    assign system_status[5] = rx_block_lock;
    assign system_status[6] = rx_am_lock;
    assign system_status[7] = rx_pcs_ready;
/*
assign user_io[0]= clk_txmac_cnt[5];
assign user_io[1]= clk_rxmac_cnt[5];
assign user_io[2]= clk50_cnt[5];
assign user_io[3]= clk100_cnt[5];
assign user_io[4]= arst;
assign user_io[5]= definetest;
// The following assignment are not used, they're used to fix warnings for unused output
assign user_io[6]= definetest;
assign user_io[7]= definetest;
assign user_io[8]= definetest;
assign user_io[9]= definetest;
*/
    probe8 prb (
       .source(source_reset),
       .probe(system_status)
    );

    assign user_led = ~system_status;
endmodule


